/***************************************************************************
 *   Copyright (C) 2005 by Rico Rommel   *
 *   ricorommel@web.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "syncfiles.h"
#include "pathtools.h"
#include <stdlib.h>
#include <pwd.h>
#include <errno.h>
#include <utime.h>
#include <string.h>
#include <libgen.h>


int SyncAllFiles(_userdata *UserData, int usercount, _fileindex *FileIndex, int filecount) {

	int filenr, usernr;
	char *destabspath, *srcabspath;
	struct passwd *srcuser, *destuser;
	struct stat deststat, srcstat, teststat;
	time_t modtime;

	uid_t procuid = getuid();
	gid_t procgid = getgid();
	
	
	for (filenr = 0; filenr < filecount; filenr++) {

//fprintf(output, "%d %s %d\n",(FileIndex+filenr)->userid, (FileIndex+filenr)->abspath, (FileIndex+filenr)->modtime);
	srcuser = getpwuid( (FileIndex+filenr)->userid );

		
		for (usernr = 0; usernr < usercount; usernr++) {
		
			//Pfas der Zeildatei zusammensetzen
			destuser = getpwuid( (UserData+usernr)->userid );

			destabspath = calloc( strlen( destuser->pw_dir ) + strlen( (UserData+usernr)->dirname ) + strlen( (FileIndex+filenr)->relpath ) +1 , 1 );
			strcat( destabspath, destuser->pw_dir );
			strcat( destabspath, (UserData+usernr)->dirname );
			strcat( destabspath, (FileIndex+filenr)->relpath );

			//Herausfiltern der aktuellsten Datei
			if ( strcmp(destabspath, (FileIndex+filenr)->abspath) != 0) {
				setfsuid( (UserData+usernr)->userid );
				
				modtime = 0;
				if (stat(destabspath, &deststat) == 0) modtime = deststat.st_mtime;


				if ((FileIndex+filenr)->modtime - modtime > (UserData+usernr)->timediff*60) {

						//eventuell übergeorndetes Verzeichnis anlegen
						
						
						setfsuid((FileIndex+filenr)->userid);
						stat((FileIndex+filenr)->abspath, &srcstat);					

				
						setfsuid((UserData+usernr)->userid);setfsgid(srcstat.st_gid);
						if ((FileIndex+filenr)->filetyp == 1) {
							if (stat(destabspath, &teststat) == -1 ) { 
								fprintf(output, "Erstelle Verzeichnis %s\n", destabspath); 
								mkdir(destabspath, srcstat.st_mode);
								}
							}

						if ((FileIndex+filenr)->filetyp == 0) {
							fprintf(output, "Synchronisiere %s", destabspath); 
							CopyFile( (FileIndex+filenr)->abspath, (FileIndex+filenr)->userid, destabspath, (UserData+usernr)->userid);
							fprintf(output, "\n");
							}
	
						//Setzen des Zeitstemples
						setfsuid((UserData+usernr)->userid);
						struct utimbuf timestamp;
						timestamp.actime = srcstat.st_atime;
						timestamp.modtime = (FileIndex+filenr)->modtime;
						utime(destabspath, &timestamp);


				}

				free(destabspath);
				
			}
		

		
		}


	}

	setfsuid( procuid );
	setfsgid( procgid );

}


int DeleteAllFiles(_userdata *UserData, int usercount) {


	int usernr, filenr, filecount;
	struct passwd *user;
	_fileindex *FileIndex;
	uid_t procuid = getuid();
	int n;

int i;
	for (usernr = 0; usernr < usercount; usernr++) {

		user = getpwuid( (UserData+usernr)->userid );

		//Fileindex erstllen
		FileIndex = CreateFileIndex((UserData+usernr), 1, &filecount); 

		setfsuid((UserData+usernr)->userid);

		for (filenr = filecount -1; filenr >= 0; filenr--) {

			if ((FileIndex+filenr)->filetyp == 0) {
				fprintf(output, "Entferne %s ", (FileIndex+filenr)->abspath);
				if (remove((FileIndex+filenr)->abspath) == -1) fprintf(output, ", Fehler: %s", strerror(errno));
				fprintf(output, "\n");
				}

			if ((FileIndex+filenr)->filetyp == 1) {
				fprintf(output, "Entferne %s ", (FileIndex+filenr)->abspath);
				if (rmdir((FileIndex+filenr)->abspath) == -1) fprintf(output, ", Fehler: %s", strerror(errno));
				fprintf(output, "\n");
				}

//			if (filenr == 0) rmdir(dirname(abspath));
			}

		
		}

	setfsuid( procuid );

}



